/* 
 * This message is auto generated by ROS#. Please DO NOT modify.
 * Note:
 * - Comments from the original code will be written in their own line 
 * - Variable sized arrays will be initialized to array of size 0 
 * Please report any issues at 
 * <https://github.com/siemens/ros-sharp> 
 */

using Newtonsoft.Json;

using RosSharp.RosBridgeClient.MessageTypes.Std;
using RosSharp.RosBridgeClient.MessageTypes.Geometry;

namespace RosSharp.RosBridgeClient.MessageTypes.PublishDataToUnity
{
    public class HagglingPoses : Message
    {
        [JsonIgnore]
        public const string RosMessageName = "publish_data_to_unity/HagglingPoses";

        //  Communicate haggling poses
        //  Include poses of avatars from haggling dataset
        public Header header;
        //  Header containing timestamp etc of this message
        public PoseArray[] bodies_all;
        //  Body motion for all 3 subjects
        public PoseArray formation;
        //  Positions and body normals for all 3 subjects
        public PoseArray faces;
        //  Face normals for all 3 subjects
        public ulong frame_num;
        //  Current frame in a data sequence
        public double[] speech_bin;
        //  e.g. [0., 1., 0.]: avatar 0 and 2 silent, avatar 1 speaking
        public ulong use_robot_id;
        //  robot replacing which avatar--0, 1, or 2
        public ulong buyer_id;
        //  the person being haggled to--0, 1, or 2
        public bool is_model_prediction;
        //  false unless it's sent from model's prediction for robot face and body rotation
        public bool ignore_robot;
        //  true when sending haggling data in test workflow

        public HagglingPoses()
        {
            this.header = new Header();
            this.bodies_all = new PoseArray[0];
            this.formation = new PoseArray();
            this.faces = new PoseArray();
            this.frame_num = 0;
            this.speech_bin = new double[0];
            this.use_robot_id = 0;
            this.buyer_id = 0;
            this.is_model_prediction = false;
            this.ignore_robot = false;
        }

        public HagglingPoses(Header header, PoseArray[] bodies_all, PoseArray formation, PoseArray faces, ulong frame_num, double[] speech_bin, ulong use_robot_id, ulong buyer_id, bool is_model_prediction, bool ignore_robot)
        {
            this.header = header;
            this.bodies_all = bodies_all;
            this.formation = formation;
            this.faces = faces;
            this.frame_num = frame_num;
            this.speech_bin = speech_bin;
            this.use_robot_id = use_robot_id;
            this.buyer_id = buyer_id;
            this.is_model_prediction = is_model_prediction;
            this.ignore_robot = ignore_robot;
        }
    }
}
